Index: cpp/tests/genoconv_test-complex.goal
===================================================================
--- cpp/tests/genoconv_test-complex.goal	(revision 1143)
+++ cpp/tests/genoconv_test-complex.goal	(revision 1263)
@@ -7,9 +7,9 @@
 *** Converted:
 Genotype:
-p:fr=1.12, ing=0.53125, as=0.15625
-p:1.0, fr=1.12, ing=0.53125, as=0.15625
-p:2.0, fr=0.976, ing=0.475, as=0.175
-j:0, 1, dx=1.0, 0.0, 0.0, stam=0.15625
-j:1, 2, dx=1.0, 0.0, 0.0, stam=0.175
+p:fr=2.2, ing=0.625
+p:1.0, fr=2.2, ing=0.625
+p:2.0, fr=1.84, ing=0.55
+j:0, 1, dx=1.0, 0.0, 0.0
+j:1, 2, dx=1.0, 0.0, 0.0
 n:j=0, d=@:p=0.6543
 n:j=1, d=G
@@ -20,33 +20,33 @@
 Comment: 
 Conversion map:
-{ [0-1] -> [0-34]
-  [2] -> [35-74,112-150]
-  [3-25] -> [188-207,219-235]
-  [26] -> [75-111,151-187]
-  [27-29] -> [208-218]
+{ [0-1] -> [0-19]
+  [2] -> [20-44,70-94]
+  [3-25] -> [120-139,151-167]
+  [26] -> [45-69,95-119]
+  [27-29] -> [140-150]
 }
-                  p:fr=1.12, ing=0.53125, as=0.15625 p:1.0, fr=1.12, ing=0.53125, as=0.15625 p:2.0, fr=0.976, ing=0.475, as=0.175 j:0, 1, dx=1.0, 0.0, 0.0, stam=0.15625 j:1, 2, dx=1.0, 0.0, 0.0, stam=0.175 n:j=0, d=@:p=0.6543 n:j=1, d=G c:0, 1, -1.23456 
-             FI : p:fr=1.12, ing=0.53125, as=0.15625 .........................................................................................................................................................................................................
-              X : ...................................p:1.0, fr=1.12, ing=0.53125, as=0.15625 .....................................j:0, 1, dx=1.0, 0.0, 0.0, stam=0.15625 .....................................................................................
-[@,p:0.6543,1:- : ............................................................................................................................................................................................n:j=0, d=@:p=0.6543 ...........c:0, 1, -1.23456 
-       1.23456] : ............................................................................................................................................................................................n:j=0, d=@:p=0.6543 ...........c:0, 1, -1.23456 
-              X : ...........................................................................p:2.0, fr=0.976, ing=0.475, as=0.175 .......................................j:1, 2, dx=1.0, 0.0, 0.0, stam=0.175 ................................................
-            [G] : ................................................................................................................................................................................................................n:j=1, d=G .................
+                  p:fr=2.2, ing=0.625 p:1.0, fr=2.2, ing=0.625 p:2.0, fr=1.84, ing=0.55 j:0, 1, dx=1.0, 0.0, 0.0 j:1, 2, dx=1.0, 0.0, 0.0 n:j=0, d=@:p=0.6543 n:j=1, d=G c:0, 1, -1.23456 
+             FI : p:fr=2.2, ing=0.625 ....................................................................................................................................................
+              X : ....................p:1.0, fr=2.2, ing=0.625 .........................j:0, 1, dx=1.0, 0.0, 0.0 .........................................................................
+[@,p:0.6543,1:- : ........................................................................................................................n:j=0, d=@:p=0.6543 ...........c:0, 1, -1.23456 
+       1.23456] : ........................................................................................................................n:j=0, d=@:p=0.6543 ...........c:0, 1, -1.23456 
+              X : .............................................p:2.0, fr=1.84, ing=0.55 .........................j:1, 2, dx=1.0, 0.0, 0.0 ................................................
+            [G] : ............................................................................................................................................n:j=1, d=G .................
 Reverse conversion map:
-{ [0-34] -> [0-1]
-  [35-74] -> [2]
-  [75-111] -> [26]
-  [112-150] -> [2]
-  [151-187] -> [26]
-  [188-207] -> [3-25]
-  [208-218] -> [27-29]
-  [219-235] -> [3-25]
+{ [0-19] -> [0-1]
+  [20-44] -> [2]
+  [45-69] -> [26]
+  [70-94] -> [2]
+  [95-119] -> [26]
+  [120-139] -> [3-25]
+  [140-150] -> [27-29]
+  [151-167] -> [3-25]
 }
                                                 FIX[@,p:0.6543,1:-1.23456]X[G]
-          p:fr=1.12, ing=0.53125, as=0.15625  : FI............................
-     p:1.0, fr=1.12, ing=0.53125, as=0.15625  : ..X...........................
-        p:2.0, fr=0.976, ing=0.475, as=0.175  : ..........................X...
-      j:0, 1, dx=1.0, 0.0, 0.0, stam=0.15625  : ..X...........................
-        j:1, 2, dx=1.0, 0.0, 0.0, stam=0.175  : ..........................X...
+                         p:fr=2.2, ing=0.625  : FI............................
+                    p:1.0, fr=2.2, ing=0.625  : ..X...........................
+                    p:2.0, fr=1.84, ing=0.55  : ..........................X...
+                    j:0, 1, dx=1.0, 0.0, 0.0  : ..X...........................
+                    j:1, 2, dx=1.0, 0.0, 0.0  : ..........................X...
                          n:j=0, d=@:p=0.6543  : ...[@,p:0.6543,1:-1.23456]....
                                   n:j=1, d=G  : ...........................[G]
@@ -72,20 +72,20 @@
                                                 Parts     Joints    Neurons
                                                 012345678901234567890123456789
-          p:fr=1.12, ing=0.53125, as=0.15625  : 0.............................
-     p:1.0, fr=1.12, ing=0.53125, as=0.15625  : .1............................
-        p:2.0, fr=0.976, ing=0.475, as=0.175  : ..2...........................
-      j:0, 1, dx=1.0, 0.0, 0.0, stam=0.15625  : ..........0...................
-        j:1, 2, dx=1.0, 0.0, 0.0, stam=0.175  : ...........1..................
+                         p:fr=2.2, ing=0.625  : 0.............................
+                    p:1.0, fr=2.2, ing=0.625  : .1............................
+                    p:2.0, fr=1.84, ing=0.55  : ..2...........................
+                    j:0, 1, dx=1.0, 0.0, 0.0  : ..........0...................
+                    j:1, 2, dx=1.0, 0.0, 0.0  : ...........1..................
                          n:j=0, d=@:p=0.6543  : ....................0.........
                                   n:j=1, d=G  : .....................1........
                             c:0, 1, -1.23456  : ....................0.........
-{ [0-34] -> [0]
-  [35-74] -> [1]
-  [75-111] -> [2]
-  [112-150] -> [10]
-  [151-187] -> [11]
-  [188-207] -> [20]
-  [208-218] -> [21]
-  [219-235] -> [20]
+{ [0-19] -> [0]
+  [20-44] -> [1]
+  [45-69] -> [2]
+  [70-94] -> [10]
+  [95-119] -> [11]
+  [120-139] -> [20]
+  [140-150] -> [21]
+  [151-167] -> [20]
 }
 