Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1222)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1264)
@@ -1680,5 +1680,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_p_ing" type="float" min="0" max="100" default="1.0">
+		<element name="f0_p_ing" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1686,8 +1686,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_new" type="float" min="0" max="100" default="3.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_del" type="float" min="0" max="100" default="3.0">
+		<element name="f0_j_new" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_del" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1695,8 +1695,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_stf" type="float" min="0" max="100" default="1.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_rsf" type="float" min="0" max="100" default="1.0">
+		<element name="f0_j_stf" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_rsf" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1725,5 +1725,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_c_wei" type="float" min="0" max="100" default="2.0">
+		<element name="f0_c_wei" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1824,14 +1824,14 @@
 		<element name="f1_smComma" type="float" min="0" max="100" default="1.0"/>
 		<element name="f1_smModif" type="float" min="0" max="100" default="4.0">
-			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiEeWwAaSsDdGgBb]]></description>
+			<description><![CDATA[Modifiers: LlRrCcQqFfMmEeWwSsAaIiDdGgBb]]></description>
 		</element>
 		<element name="f1_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
-(all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
+(all: LlRrCcQqFfMmEeWwSsAaIiDdGgBb)]]></description>
 		</element>
 		<element name="f1_nmNeu" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Adds a (connected) neuron or removes a neuron]]></description>
 		</element>
-		<element name="f1_nmConn" type="float" min="0" max="100" default="1.0">
+		<element name="f1_nmConn" type="float" min="0" max="100" default="2.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1839,5 +1839,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f1_nmWei" type="float" min="0" max="100" default="2.0"/>
+		<element name="f1_nmWei" type="float" min="0" max="100" default="1.0"/>
 		<element name="f1_nmVal" type="float" min="0" max="100" default="1.0"/>
 		<element name="f2_mutAddOper" type="float" min="0" max="1" default="0.4">
@@ -1889,43 +1889,40 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f4_mut_add" type="float" min="0" max="100" default="50.0">
+		<element name="f4_mut_add" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Mutation: probability of adding a node]]></description>
 		</element>
-		<element name="f4_mut_add_div" type="float" min="0" max="100" default="20.0">
+		<element name="f4_mut_add_div" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Add node mutation: probability of adding a division]]></description>
 		</element>
-		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="15.0">
+		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Add node mutation: probability of adding a neural connection]]></description>
 		</element>
-		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="5.0">
+		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Add node mutation: probability of adding a neuron property/modifier]]></description>
 		</element>
-		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[Add node mutation: probability of adding a repetition]]></description>
-		</element>
-		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="50.0">
+		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[Add node mutation: probability of adding the '#' repetition gene]]></description>
+		</element>
+		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Add node mutation: probability of adding a random, simple gene]]></description>
 		</element>
-		<element name="f4_mut_del" type="float" min="0" max="100" default="20.0">
+		<element name="f4_mut_del" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Mutation: probability of deleting a node]]></description>
 		</element>
-		<element name="f4_mut_mod" type="float" min="0" max="100" default="30.0">
+		<element name="f4_mut_mod" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Mutation: probability of changing a node]]></description>
 		</element>
-		<element name="f4_mut_modneu_type" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[Neuron mutation: probability of changing its type]]></description>
-		</element>
-		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="30.0">
-			<description><![CDATA[Neuron mutation: probability of changing its connection]]></description>
-		</element>
-		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="60.0">
-			<description><![CDATA[Neuron mutation: probability of changing its weight]]></description>
-		</element>
-		<element name="f4_mut_neu_nonsensors" type="float" min="0" max="100" default="100.0">
-			<description><![CDATA[[Experimental] Neuron mutation: probability of using as an input to another neuron not only sensors, but also other neurons (more diversity) that require no inputs]]></description>
+		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[Neuron input mutation: probability of changing its source neuron]]></description>
+		</element>
+		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[Neuron input mutation: probability of changing its weight]]></description>
+		</element>
+		<element name="f4_mut_max_rep" type="integer" min="2" max="20" default="6">
+			<description><![CDATA[Maximum allowed number of repetitions for the '#' repetition gene]]></description>
 		</element>
 		<element name="f4_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
-(all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
+(all: LlRrCcQqFfMmEeWwSsAaIiDdGgBb)]]></description>
 		</element>
 		<element name="f8_mut_chg_begin_arg" type="float" min="0" max="100" default="7.0">
@@ -2026,23 +2023,23 @@
 			<description><![CDATA[Probability of crossing over by random distribution of genes from both parents to both children]]></description>
 		</element>
-		<element name="fH_mut_addition" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_addition" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of adding new element to genotype]]></description>
 		</element>
-		<element name="fH_mut_add_joint" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_joint" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new stick handle]]></description>
 		</element>
-		<element name="fH_mut_add_neuron" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_neuron" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new neuron handle]]></description>
 		</element>
-		<element name="fH_mut_add_connection" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_connection" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new neuron connection handle]]></description>
 		</element>
-		<element name="fH_mut_deletion" type="float" min="0" max="1" default="0.1">
+		<element name="fH_mut_deletion" type="float" min="0" max="100" default="10.0">
 			<description><![CDATA[Probability of removing element from genotype]]></description>
 		</element>
-		<element name="fH_mut_handle" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_handle" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of changing values in vectors of handle]]></description>
 		</element>
-		<element name="fH_mut_property" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_property" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of changing properties of handles]]></description>
 		</element>
@@ -2259,4 +2256,38 @@
 				<argument type="Vector"/>
 			</arguments>
+		</element>
+	</type>
+	<type name="GenoConverters" context="Global context">
+<description><![CDATA[Converters between genetic formats]]></description>
+		<element name="genoconv_f1_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f2_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f3_f2" type="integer" min="0" max="1"/>
+		<element name="genoconv_f4_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f8_f1" type="integer" min="0" max="1"/>
+		<element name="genoconv_f9_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fF_f0s" type="integer" min="0" max="1"/>
+		<element name="genoconv_fn_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fB_fH" type="integer" min="0" max="1"/>
+		<element name="genoconv_fH_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fL_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fS_f0s" type="integer" min="0" max="1"/>
+		<element name="conv_f1_f0_modcompat" type="integer" min="0" max="1" default="1">
+			<description><![CDATA[The modern implementation makes the influence of modifiers more consistent and uniform, and the extreme property values are easier to reach with a lower number of characters, which improves the topology for evolutionary search.
+Previous implementation can be enabled for compatibility, for example when you want to test old genotypes.]]></description>
+		</element>
+		<element name="conv_f1_f0_cq_influence" type="integer" min="0" max="1" default="1">
+			<description><![CDATA['C' and 'Q' modifier semantics was changed in June 2023. Previously they did not affect the stick immediately following the current sequence of modifiers. In the modern implementation, all modifiers consistently start their influence at the very next stick that is being created in the current branch.
+Example:
+In the old interpretation of 'XcXX', only the last stick is rotated, because 'c' starts its influence at the stick that occurs after the current stick. In the modern implementation, the same effect is achieved with 'XXcX', where 'c' immediately bends the first 'X' that appears after it.
+Previous implementation can be enabled for compatibility, for example when you want to test old genotypes.]]></description>
+		</element>
+		<element name="conv_f1_f0_branch_muscle_range" type="integer" min="0" max="2" default="0">
+			<description><![CDATA[Determines how the bending muscle default turning range is limited when the muscle is controlling a stick growing from a branching point that has 'NumberOfBranches' sticks separated by commas. The motivation of the limited range is to keep the neighboring sticks from intersecting when they are bent by muscles. This constraint may degrade the performance (e.g. velocity) of creatures, but this default value can be overridden by providing a specific range property value for the '|' muscle neuron in the genotype.
+- Full/NumberOfBranches - a compromise between the two other settings.
+- Full/(NumberOfBranches+1) - because the originating stick also counts as a branch. This setting guarantees that in the worst case, when at least two neighboring branches have sticks controlled by bending muscles and their controlling signals are at extreme values, the sticks can touch and overlap, but will not intersect. This setting is in most cases too strict because (1) all branches are very rarely controlled by muscles, (2) there are often 'empty' branches - multiple commas with no sticks in-between, and (3) the share of the originating stick is effectively wasted because this stick itself has no muscle at the branching point so it will not bend; the muscle bending range is symmetrical and the default range is equal for all muscles in a branching, but the sticks equipped with muscles in a branching are rarely evenly spaced.
+- Full: Always 1 (the complete angle) - because we do not have to care about the physical plausibility and avoid intersecting sticks, and other genetic representations do not impose such constraints, so this full angle setting can be useful as the default bending range when comparing the performance of various genetic encodings.]]></description>
+		</element>
+		<element name="conv_f8_f1_maxlen" type="integer" min="10" max="10000" default="500">
+			<description><![CDATA[Maximal length of the resulting f1 genotype, in characters. If the f8 L-system produces longer f1 genotype, it will be considered invalid.]]></description>
 		</element>
 	</type>
@@ -2546,5 +2577,5 @@
 		<element name="hyn" type="float" min="-6.2832" max="0" default="-1.5708"/>
 		<element name="hyp" type="float" min="0" max="6.2832" default="1.5708" flags="1024"/>
-		<element name="stif" type="float" min="0" max="1" default="1.0"/>
+		<element name="stif" type="float" min="0.01" max="1" default="1.0"/>
 		<element name="rotstif" type="float" min="0" max="1" default="1.0"/>
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>
@@ -4332,4 +4363,5 @@
 		<element name="expstate" type="ExpState" flags="35"/>
 		<element name="genman" type="GenMan" flags="35"/>
+		<element name="genoconverters" type="GenoConverters" flags="35"/>
 		<element name="reloadNeurons" function="true" type="void" flags="32"><arguments/></element>
 		<element name="userdata" type="untyped" flags="34"/>
@@ -4930,5 +4962,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_p_ing" type="float" min="0" max="100" default="1.0">
+		<element name="f0_p_ing" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4936,8 +4968,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_new" type="float" min="0" max="100" default="3.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_del" type="float" min="0" max="100" default="3.0">
+		<element name="f0_j_new" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_del" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4945,8 +4977,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_stf" type="float" min="0" max="100" default="1.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_rsf" type="float" min="0" max="100" default="1.0">
+		<element name="f0_j_stf" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_rsf" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4975,5 +5007,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_c_wei" type="float" min="0" max="100" default="2.0">
+		<element name="f0_c_wei" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5074,14 +5106,14 @@
 		<element name="f1_smComma" type="float" min="0" max="100" default="1.0"/>
 		<element name="f1_smModif" type="float" min="0" max="100" default="4.0">
-			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiEeWwAaSsDdGgBb]]></description>
+			<description><![CDATA[Modifiers: LlRrCcQqFfMmEeWwSsAaIiDdGgBb]]></description>
 		</element>
 		<element name="f1_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
-(all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
+(all: LlRrCcQqFfMmEeWwSsAaIiDdGgBb)]]></description>
 		</element>
 		<element name="f1_nmNeu" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Adds a (connected) neuron or removes a neuron]]></description>
 		</element>
-		<element name="f1_nmConn" type="float" min="0" max="100" default="1.0">
+		<element name="f1_nmConn" type="float" min="0" max="100" default="2.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5089,5 +5121,5 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f1_nmWei" type="float" min="0" max="100" default="2.0"/>
+		<element name="f1_nmWei" type="float" min="0" max="100" default="1.0"/>
 		<element name="f1_nmVal" type="float" min="0" max="100" default="1.0"/>
 		<element name="f2_mutAddOper" type="float" min="0" max="1" default="0.4">
@@ -5139,43 +5171,40 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f4_mut_add" type="float" min="0" max="100" default="50.0">
+		<element name="f4_mut_add" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Mutation: probability of adding a node]]></description>
 		</element>
-		<element name="f4_mut_add_div" type="float" min="0" max="100" default="20.0">
+		<element name="f4_mut_add_div" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Add node mutation: probability of adding a division]]></description>
 		</element>
-		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="15.0">
+		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Add node mutation: probability of adding a neural connection]]></description>
 		</element>
-		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="5.0">
+		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Add node mutation: probability of adding a neuron property/modifier]]></description>
 		</element>
-		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[Add node mutation: probability of adding a repetition]]></description>
-		</element>
-		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="50.0">
+		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[Add node mutation: probability of adding the '#' repetition gene]]></description>
+		</element>
+		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Add node mutation: probability of adding a random, simple gene]]></description>
 		</element>
-		<element name="f4_mut_del" type="float" min="0" max="100" default="20.0">
+		<element name="f4_mut_del" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Mutation: probability of deleting a node]]></description>
 		</element>
-		<element name="f4_mut_mod" type="float" min="0" max="100" default="30.0">
+		<element name="f4_mut_mod" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[Mutation: probability of changing a node]]></description>
 		</element>
-		<element name="f4_mut_modneu_type" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[Neuron mutation: probability of changing its type]]></description>
-		</element>
-		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="30.0">
-			<description><![CDATA[Neuron mutation: probability of changing its connection]]></description>
-		</element>
-		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="60.0">
-			<description><![CDATA[Neuron mutation: probability of changing its weight]]></description>
-		</element>
-		<element name="f4_mut_neu_nonsensors" type="float" min="0" max="100" default="100.0">
-			<description><![CDATA[[Experimental] Neuron mutation: probability of using as an input to another neuron not only sensors, but also other neurons (more diversity) that require no inputs]]></description>
+		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[Neuron input mutation: probability of changing its source neuron]]></description>
+		</element>
+		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[Neuron input mutation: probability of changing its weight]]></description>
+		</element>
+		<element name="f4_mut_max_rep" type="integer" min="2" max="20" default="6">
+			<description><![CDATA[Maximum allowed number of repetitions for the '#' repetition gene]]></description>
 		</element>
 		<element name="f4_mut_exmod" type="string" max="30">
 			<description><![CDATA[Modifiers that will not be added nor deleted during mutation
-(all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
+(all: LlRrCcQqFfMmEeWwSsAaIiDdGgBb)]]></description>
 		</element>
 		<element name="f8_mut_chg_begin_arg" type="float" min="0" max="100" default="7.0">
@@ -5276,23 +5305,23 @@
 			<description><![CDATA[Probability of crossing over by random distribution of genes from both parents to both children]]></description>
 		</element>
-		<element name="fH_mut_addition" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_addition" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of adding new element to genotype]]></description>
 		</element>
-		<element name="fH_mut_add_joint" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_joint" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new stick handle]]></description>
 		</element>
-		<element name="fH_mut_add_neuron" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_neuron" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new neuron handle]]></description>
 		</element>
-		<element name="fH_mut_add_connection" type="float" min="0" max="1" default="0.33">
+		<element name="fH_mut_add_connection" type="float" min="0" max="100" default="33.0">
 			<description><![CDATA[Probability of adding new neuron connection handle]]></description>
 		</element>
-		<element name="fH_mut_deletion" type="float" min="0" max="1" default="0.1">
+		<element name="fH_mut_deletion" type="float" min="0" max="100" default="10.0">
 			<description><![CDATA[Probability of removing element from genotype]]></description>
 		</element>
-		<element name="fH_mut_handle" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_handle" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of changing values in vectors of handle]]></description>
 		</element>
-		<element name="fH_mut_property" type="float" min="0" max="1" default="0.3">
+		<element name="fH_mut_property" type="float" min="0" max="100" default="30.0">
 			<description><![CDATA[Probability of changing properties of handles]]></description>
 		</element>
@@ -5411,16 +5440,35 @@
 			<description><![CDATA[Add part mutation will produce more parametrized parts]]></description>
 		</element>
-		<element name="genkonw0" type="integer" min="0" max="1"/>
-		<element name="genkonw1" type="integer" min="0" max="1"/>
-		<element name="genkonw2" type="integer" min="0" max="1"/>
-		<element name="genkonw3" type="integer" min="0" max="1"/>
-		<element name="genkonw4" type="integer" min="0" max="1"/>
-		<element name="genkonw5" type="integer" min="0" max="1"/>
-		<element name="genkonw6" type="integer" min="0" max="1"/>
-		<element name="genkonw7" type="integer" min="0" max="1"/>
-		<element name="genkonw8" type="integer" min="0" max="1"/>
-		<element name="genkonw9" type="integer" min="0" max="1"/>
-		<element name="genkonw10" type="integer" min="0" max="1"/>
-		<element name="genkonw11" type="integer" min="0" max="1"/>
+		<element name="genoconv_f1_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f2_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f3_f2" type="integer" min="0" max="1"/>
+		<element name="genoconv_f4_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_f8_f1" type="integer" min="0" max="1"/>
+		<element name="genoconv_f9_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fF_f0s" type="integer" min="0" max="1"/>
+		<element name="genoconv_fn_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fB_fH" type="integer" min="0" max="1"/>
+		<element name="genoconv_fH_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fL_f0" type="integer" min="0" max="1"/>
+		<element name="genoconv_fS_f0s" type="integer" min="0" max="1"/>
+		<element name="conv_f1_f0_modcompat" type="integer" min="0" max="1" default="1">
+			<description><![CDATA[The modern implementation makes the influence of modifiers more consistent and uniform, and the extreme property values are easier to reach with a lower number of characters, which improves the topology for evolutionary search.
+Previous implementation can be enabled for compatibility, for example when you want to test old genotypes.]]></description>
+		</element>
+		<element name="conv_f1_f0_cq_influence" type="integer" min="0" max="1" default="1">
+			<description><![CDATA['C' and 'Q' modifier semantics was changed in June 2023. Previously they did not affect the stick immediately following the current sequence of modifiers. In the modern implementation, all modifiers consistently start their influence at the very next stick that is being created in the current branch.
+Example:
+In the old interpretation of 'XcXX', only the last stick is rotated, because 'c' starts its influence at the stick that occurs after the current stick. In the modern implementation, the same effect is achieved with 'XXcX', where 'c' immediately bends the first 'X' that appears after it.
+Previous implementation can be enabled for compatibility, for example when you want to test old genotypes.]]></description>
+		</element>
+		<element name="conv_f1_f0_branch_muscle_range" type="integer" min="0" max="2" default="0">
+			<description><![CDATA[Determines how the bending muscle default turning range is limited when the muscle is controlling a stick growing from a branching point that has 'NumberOfBranches' sticks separated by commas. The motivation of the limited range is to keep the neighboring sticks from intersecting when they are bent by muscles. This constraint may degrade the performance (e.g. velocity) of creatures, but this default value can be overridden by providing a specific range property value for the '|' muscle neuron in the genotype.
+- Full/NumberOfBranches - a compromise between the two other settings.
+- Full/(NumberOfBranches+1) - because the originating stick also counts as a branch. This setting guarantees that in the worst case, when at least two neighboring branches have sticks controlled by bending muscles and their controlling signals are at extreme values, the sticks can touch and overlap, but will not intersect. This setting is in most cases too strict because (1) all branches are very rarely controlled by muscles, (2) there are often 'empty' branches - multiple commas with no sticks in-between, and (3) the share of the originating stick is effectively wasted because this stick itself has no muscle at the branching point so it will not bend; the muscle bending range is symmetrical and the default range is equal for all muscles in a branching, but the sticks equipped with muscles in a branching are rarely evenly spaced.
+- Full: Always 1 (the complete angle) - because we do not have to care about the physical plausibility and avoid intersecting sticks, and other genetic representations do not impose such constraints, so this full angle setting can be useful as the default bending range when comparing the performance of various genetic encodings.]]></description>
+		</element>
+		<element name="conv_f8_f1_maxlen" type="integer" min="10" max="10000" default="500">
+			<description><![CDATA[Maximal length of the resulting f1 genotype, in characters. If the f8 L-system produces longer f1 genotype, it will be considered invalid.]]></description>
+		</element>
 		<element name="randinit" type="float" min="0" max="10" default="0.01">
 			<description><![CDATA[Allowed range for initializing all neuron states with uniform distribution random numbers and zero mean. Set to 0 for deterministic initialization.]]></description>
@@ -6168,4 +6216,5 @@
 		<element name="expstate" type="ExpState" flags="35"/>
 		<element name="genman" type="GenMan" flags="35"/>
+		<element name="genoconverters" type="GenoConverters" flags="35"/>
 		<element name="reloadNeurons" function="true" type="void" flags="32"><arguments/></element>
 		<element name="userdata" type="untyped" flags="34"/>
@@ -7954,5 +8003,5 @@
 		<element name="hyn" type="float" min="-6.2832" max="0" default="-1.5708"/>
 		<element name="hyp" type="float" min="0" max="6.2832" default="1.5708" flags="1024"/>
-		<element name="stif" type="float" min="0" max="1" default="1.0"/>
+		<element name="stif" type="float" min="0.01" max="1" default="1.0"/>
 		<element name="rotstif" type="float" min="0" max="1" default="1.0"/>
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>